// Matthias Hollnder 2013
#version 430 core

#pragma MX_PORT_SURFACE(o_FragData,"Color-Target","Color");

//////////////////////////////////////////////////////////////////////////
// Input textures
//////////////////////////////////////////////////////////////////////////
layout( binding = 0 ) uniform samplerCube cubeTexture;

//////////////////////////////////////////////////////////////////////////
// Incoming data
//////////////////////////////////////////////////////////////////////////
in block
{
	vec3 			WorldSpace;
	vec3 			Normal;
} In;

uniform vec3		CameraPosition;

//////////////////////////////////////////////////////////////////////////
// output variables
//////////////////////////////////////////////////////////////////////////

layout( location = 0, index = 0 ) out vec4 o_FragData;


vec4 ComputeOutput()
{
	vec3 vNormal = normalize( In.Normal );
	vec3 vWorldSpace = In.WorldSpace;
	vec3 vEye = vWorldSpace - CameraPosition;
	vec4 vColor = vec4( 0.0 );

	//vec3 vReflect = reflect( vEye, vNormal );
	vec3 vReflect = normalize( reflect( vEye, vNormal ) );
	
	vColor.w = 1.0;

	vColor.xyz = vNormal;
	
	//vColor = texture( cubeTexture, vNormal );
	vColor = texture( cubeTexture, vReflect );
	
	// for debugging:
	//vColor.xyz = u_Material.m_vDiffuse.xyz;
	//vColor.xyz = vNormal;
	//vColor.xyz = ( dot( vNormal, vNormal ) > 0.5 ) ? vColor.xyz : vMatDiffuse.xyz;
	
	return vColor;
}


//////////////////////////////////////////////////////////////////////////
// Fragment Shader
//////////////////////////////////////////////////////////////////////////
void main()
{
	o_FragData = ComputeOutput();
}
