// Matthias Hollnder 2013
#version 430 core

#pragma MX_PORT_SURFACE(o_FragColor,"Color-Target","Color");
#pragma MX_PORT_SURFACE(o_FragNormal,"Normal-Target","Normal");
#pragma MX_PORT_SURFACE(o_FragTexCoord,"TexCoord-Target","TexCoord");

#pragma MX_PORT_SURFACE(o_WorldSpace,"WorldSpace-Target","WorldSpace");

//////////////////////////////////////////////////////////////////////////
// Input textures
//////////////////////////////////////////////////////////////////////////
layout( binding = 0 ) uniform sampler2D sampTexture;

//////////////////////////////////////////////////////////////////////////
// Incoming data
//////////////////////////////////////////////////////////////////////////
in block
{
	vec3 Normal;
	vec3 WorldSpace;
	vec2 TexCoord;
} In;

//////////////////////////////////////////////////////////////////////////
// output variables
//////////////////////////////////////////////////////////////////////////

layout( location = 0 ) out vec4 o_FragColor;
layout( location = 1 ) out vec3 o_FragNormal;
layout( location = 2 ) out vec3 o_FragTexCoord;
layout( location = 3 ) out vec3 o_WorldSpace;

//////////////////////////////////////////////////////////////////////////
// Fragment Shader
//////////////////////////////////////////////////////////////////////////
void main()
{
	vec4 vTexColor = texture( sampTexture, In.TexCoord ).xyzw;
	//if ( vTexColor.w <= 0.4 ) discard;
	o_FragColor = vTexColor;
	o_FragNormal = normalize( In.Normal );
	o_FragTexCoord = vec3( In.TexCoord, 0.0 );
	o_WorldSpace = In.WorldSpace;
}
