// Matthias Hollnder 2013
#version 430 core

//~ #pragma MX_PORT_ATTRIBUTE(Position,"Positions");
//~ #pragma MX_PORT_ATTRIBUTE(Normal,"Normals");
//~ #pragma MX_PORT_ATTRIBUTE(TexCoord,"TexCoords");

//////////////////////////////////////////////////////////////////////////
// input variables
//////////////////////////////////////////////////////////////////////////
layout( location = 0 ) uniform mat4 MVP;
layout( location = 1 ) uniform mat4 WorldMatrix;
layout( location = 2 ) uniform mat3 NormalMatrix;

layout( location = 0 ) in vec3 Position;
layout( location = 1 ) in vec3 Normal;
layout( location = 2 ) in vec2 TexCoord;

//////////////////////////////////////////////////////////////////////////
// Specify exactly what the gl_PerVertex output contains
//////////////////////////////////////////////////////////////////////////
out gl_PerVertex
{
    vec4 gl_Position;
};

//////////////////////////////////////////////////////////////////////////
// Other output
//////////////////////////////////////////////////////////////////////////
out block
{
	vec3 Normal;
	vec3 WorldSpace;
	vec2 TexCoord;
} Out;

//////////////////////////////////////////////////////////////////////////
// Vertex-Shader
//////////////////////////////////////////////////////////////////////////
void main()
{	
	vec4 vWorldSpace = WorldMatrix * vec4( Position, 1.0 );
	Out.Normal = NormalMatrix * Normal;
	Out.WorldSpace = vWorldSpace.xyz / vWorldSpace.w;
	Out.TexCoord = TexCoord;

	gl_Position = MVP * vec4( Position, 1.0 );
}
