// Matthias Hollnder 2013
#version 430 core

//////////////////////////////////////////////////////////////////////////
// Input textures
//////////////////////////////////////////////////////////////////////////
layout( binding = 0 ) uniform sampler2D fontTexture;
layout( location = 3 ) uniform vec3 vTextColor;

//////////////////////////////////////////////////////////////////////////
// output variables
//////////////////////////////////////////////////////////////////////////
layout( location = 0, index = 0 ) out vec4 o_FragData;

//////////////////////////////////////////////////////////////////////////
// Incoming data
//////////////////////////////////////////////////////////////////////////
in block
{
	vec2 vTexCoord;
} In;


vec4 ComputeColor()
{
	vec4 vColor = texture( fontTexture, In.vTexCoord );
	return vColor;
}

//////////////////////////////////////////////////////////////////////////
// Fragment Shader
//////////////////////////////////////////////////////////////////////////
void main()
{
	//~ o_FragData = vec4( 0.0, 1.0, 0.0, 1.0 );
	//~ o_FragData = ComputeColor();
	//~ return;
	
	vec4 vColor = ComputeColor();
	if ( dot( vColor.xyz, vColor.xyz ) < 0.1 ) {
		discard;
	}
	else {
		//~ o_FragData = vec4( 0.0, 1.0, 0.0, 1.0 );
		o_FragData = vColor * vec4( vTextColor, 1.0 );
	}
}
