// Matthias Hollnder 2013
#version 430 core

//////////////////////////////////////////////////////////////////////////
// input variables
//////////////////////////////////////////////////////////////////////////
layout( location = 0 ) in vec3 Position;
layout( location = 1 ) in int Character;	// stepping by instance

//////////////////////////////////////////////////////////////////////////
// uniform variables
//////////////////////////////////////////////////////////////////////////
layout( location = 0 ) uniform float fCharacterOffset;
layout( location = 1 ) uniform vec2 vCharacterScale;
layout( location = 2 ) uniform vec2 vScreenPos;

//////////////////////////////////////////////////////////////////////////
// Specify exactly what the gl_PerVertex output contains
//////////////////////////////////////////////////////////////////////////
out gl_PerVertex
{
    vec4 gl_Position;
};

//////////////////////////////////////////////////////////////////////////
// Other output
//////////////////////////////////////////////////////////////////////////
out block
{
	vec2 vTexCoord;
} Out;

//////////////////////////////////////////////////////////////////////////
// Vertex-Shader
//////////////////////////////////////////////////////////////////////////

void Best()
{
	//vec4 vPosition = MVP * vec4( Position, 1.0 );
	
	vec4 vPosition = vec4( Position, 1.0 );
	vPosition.xy *= vCharacterScale;
	vPosition.xy += vScreenPos;
	
	//vPosition.x += float( gl_InstanceID ) * fCharacterOffset;
	vPosition.x += float( gl_InstanceID ) * vCharacterScale.x;
	
	gl_Position = vPosition;
	
	
	
	int iCharacter = Character;
	//~ int iCharacter = int( gl_InstanceID ) + 10;
	//~ int iCharacter = 1;
	
	vec2 vCharacterTexCoord = vec2( 0.0 );
	vCharacterTexCoord.x += float( iCharacter ) * fCharacterOffset;
	vCharacterTexCoord.x += Position.x * fCharacterOffset;
	vCharacterTexCoord.y = Position.y;
	Out.vTexCoord =  vCharacterTexCoord;
}


void main()
{	
	Best();
	//~ vec4 vPosition = vec4( Position, 1.0 );
	//~ gl_Position = vPosition;
	//~ Out.vTexCoord = vPosition.xy;
}
